﻿

namespace FileSynchronizer.Objects
{
    //---------------------------------------------------------------------------------------------------------------------------------------
    // Code based upon the State Pattern, as described by the GOF
    //
    // http://en.wikipedia.org/wiki/State_pattern and http://en.wikipedia.org/wiki/Talk:State_pattern#Disputed
    //
    // This is a Concrete State Object
    //
    //---------------------------------------------------------------------------------------------------------------------------------------

    class ProgramState_Minimized_Idle : ProgramState
    {
        #region Constructors
        //---------------------------------------------------------------------------------------------------------------------------------------
        public ProgramState_Minimized_Idle(ProgramContext TheProgramContext)
            : base(TheProgramContext)
        {
        }
        //---------------------------------------------------------------------------------------------------------------------------------------
        #endregion

        #region Public Methods
        //---------------------------------------------------------------------------------------------------------------------------------------
        // Called when we want to 'Un-Minimize' the ProgramState
        //---------------------------------------------------------------------------------------------------------------------------------------
        public override bool RunNotMinimized()
        {
            bool OperationResult = false;

            ChangeState(new ProgramState_Idle(CurrentProgramContext));
            CurrentProgramContext.CurrentState = State.Idle;

            return OperationResult;
        }
        //---------------------------------------------------------------------------------------------------------------------------------------
        #endregion
    }
}
